<id>
din1031:mlistpositionfilter
</id>

<version>
1.1.0
</version>

<edit file>
$sourcedir/ManageMembers.php
</edit file>

<search for>
		'all' => array('ViewMemberlist', 'moderate_forum'),
</search for>

<replace>
		'all' => array('ViewMemberlist', 'moderate_forum'),
		'mlistsettings' => array('ModifyMlistFilterSettings', 'moderate_forum'),
</replace>

<search for>
			'viewmembers' => array(
				'title' => $txt[303],
				'description' => $txt[11],
				'href' => $scripturl . '?action=viewmembers;sa=all',
				'is_selected' => $_REQUEST['sa'] == 'all',
			),
</search for>

<replace>
			'viewmembers' => array(
				'title' => $txt[303],
				'description' => $txt[11],
				'href' => $scripturl . '?action=viewmembers;sa=all',
				'is_selected' => $_REQUEST['sa'] == 'all',
			),
			'mlistsettings' => array(
				'title' => $txt['mlist_filter_title'],
				'description' => $txt['mlist_filter_desc'],
				'href' => $scripturl . '?action=viewmembers;sa=mlistsettings',
				'is_selected' => $_REQUEST['sa'] == 'mlistsettings',
			),
</replace>

<search for>
function jeffsdatediff($old)
{
</search for>

<replace>
//So here are the Settinge for the Member List filter... hope you need it :)
function ModifyMlistFilterSettings()
{
	global $txt, $scripturl, $context, $settings, $sc, $db_prefix, $modSettings;

	// Setup the template.
	$context['sub_template'] = 'mlist_filter_settings';
	$context['page_title'] = $txt['mlist_filter_title'];

	// Wanna save this page?
	if (isset($_POST['save_settings']))
	{
		checkSession();
		
		global $func;
		//Allowed Groups ;)
		if(!empty($_POST['mlist_noAdditionalGroups'])) {
			$new_array = array();
			foreach($_POST['mlist_noAdditionalGroups'] as $i) {
				$i = (int) $i;
				if(!empty($i))
					$new_array[$i] = $i;
			}
			$_POST['mlist_noAdditionalGroups'] = implode(',', $new_array);
		}		
		
		if(!empty($_POST['mlist_notSearchableGroups'])) {
			$new_array = array();
			foreach($_POST['mlist_notSearchableGroups'] as $i) {
				$i = (int) $i;
				if(!empty($i))
					$new_array[$i] = $i;
			}
			$_POST['mlist_notSearchableGroups'] = implode(',', $new_array);
		}
		
		// Update the actual settings.
		updateSettings(array(
			'mlist_disableFilter' => empty($_POST['mlist_disableFilter']) ? '0' : '1',
			'mlist_loadAdditionalGroups' => empty($_POST['mlist_loadAdditionalGroups']) ? '0' : '1',
			'mlist_noAdditionalGroups' => empty($_POST['mlist_noAdditionalGroups']) ? '' : $_POST['mlist_noAdditionalGroups'],
			'mlist_notSearchableGroups' => empty($_POST['mlist_notSearchableGroups']) ? '' : $_POST['mlist_notSearchableGroups'],
		));

		redirectexit('action=viewmembers;sa=mlistsettings');
	}

	//Load membergroups.
	$modSettings['mlist_noAdditionalGroups'] = !empty($modSettings['mlist_noAdditionalGroups']) ? explode(',', $modSettings['mlist_noAdditionalGroups']) : array();
	$modSettings['mlist_notSearchableGroups'] = !empty($modSettings['mlist_notSearchableGroups']) ? explode(',', $modSettings['mlist_notSearchableGroups']) : array();
	$request = db_query("
		SELECT groupName, ID_GROUP, minPosts
		FROM {$db_prefix}membergroups
		ORDER BY minPosts, ID_GROUP != 1, ID_GROUP != 2, ID_GROUP != 3, groupName", __FILE__, __LINE__);
	$context['groups'] = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$context['groups'][(int) $row['ID_GROUP']] = array(
			'id' => $row['ID_GROUP'],
			'name' => trim($row['groupName']),
			'checked' => in_array($row['ID_GROUP'], $modSettings['mlist_notSearchableGroups']),
			'is_post_group' => $row['minPosts'] != -1,
		);
	}
	mysql_free_result($request);

	//No Moderators!!!
	unset($context['groups']['3']);

	//I Generate the Second array for the other System
	$context['groups_2'] = array();
	foreach($context['groups'] as $id => $value) {
		if(!$value['is_post_group']) {
			$value['checked'] = in_array($id, $modSettings['mlist_noAdditionalGroups']);
			$context['groups_2'][$id] = $value;
		}
	}
	
	//Sorry for the lazyness... but it's easier...
	loadLanguage('ManageBoards');
}

function jeffsdatediff($old)
{
</replace>

<edit file>
$sourcedir/Memberlist.php
</edit file>

<search for>
		'all' => array(&$txt[303], 'MLAll', $context['listing_by'] == 'all'),
</search for>

<replace>
		'all' => array(&$txt[303], 'MLAll', $context['listing_by'] == 'all'),
		'position' => array(&$txt['mlist_search_group'], 'MLPosition', $context['listing_by'] == 'position'),
</replace>

<search for>
	// Set up the sort links.
	$context['sort_links'] = array();
</search for>

<replace>
	//Disabled?
	if(!empty($modSettings['mlist_disableFilter']))
		unset($subActions['position']);

	// Set up the sort links.
	$context['sort_links'] = array();
</replace>

<search for>
	$context['can_send_pm'] = allowedTo('pm_send');
</search for>

<replace>
	$context['can_send_pm'] = allowedTo('pm_send');

	if(empty($modSettings['mlist_disableFilter'])) {
		//Preload Membergoups :) and set some Standards
		global $db_prefix;
		$context['ID_GROUP'] = 0; 

		$request = db_query("
			SELECT groupName, ID_GROUP, minPosts
			FROM {$db_prefix}membergroups
			WHERE ID_GROUP != 3
			ORDER BY minPosts, ID_GROUP != 1, ID_GROUP != 2, groupName", __FILE__, __LINE__);
		while ($row = mysql_fetch_assoc($request))
		{
			$context['groups'][(int) $row['ID_GROUP']] = array(
				'id' => $row['ID_GROUP'],
				'name' => trim($row['groupName']),
				'is_post_group' => $row['minPosts'] != -1,
			);
		}
		mysql_free_result($request);

		//This is really a fast way to remove the groups who not allowed to see :D
		if(!empty($modSettings['mlist_notSearchableGroups'])) {
			if(!is_array($modSettings['mlist_notSearchableGroups']))
				$modSettings['mlist_notSearchableGroups'] = explode(',', $modSettings['mlist_notSearchableGroups']);
			foreach($modSettings['mlist_notSearchableGroups'] as $id) 
				unset($context['groups'][$id]);
		}
		
		if(empty($context['groups']))
			$modSettings['mlist_disableFilter'] = '1';
	}
	else {
		$context['ID_GROUP'] = 0;
		$context['groups'] = array();
	}
</replace>

<search for>
function printMemberListRows($request)
{
</search for>

<replace>
// Filter Memberlist by Membergroups.
function MLPosition()
{
	global $txt, $scripturl, $db_prefix, $user_info, $settings;
	global $modSettings, $context, $func;

	if(!empty($modSettings['mlist_disableFilter']) || empty($context['groups'])) 
		redirectexit('action=mlist');

	//Nothing set? Hacking?
	$_REQUEST['position'] = !isset($_REQUEST['position']) ? 0 : (int) $_REQUEST['position'];
	
	if(empty($_REQUEST['position']) || !isset($context['groups'][$_REQUEST['position']])) 
		$currentGroup = current($context['groups']); //Take the first item i found ;)
	else
		$currentGroup = $context['groups'][$_REQUEST['position']];
	
	//Set the id for later.	
	$context['ID_GROUP'] = $currentGroup['id'];

	//Should i load Additional Groups or should i remove some groups from this?
	$loadAdditionalGroups = empty($modSettings['mlist_loadAdditionalGroups']);
	if($loadAdditionalGroups && !empty($modSettings['mlist_noAdditionalGroups'])) {
		if(!is_array($modSettings['mlist_noAdditionalGroups']))
			$modSettings['mlist_noAdditionalGroups'] = explode(',', $modSettings['mlist_noAdditionalGroups']);
		$loadAdditionalGroups = !in_array($context['ID_GROUP'], $modSettings['mlist_noAdditionalGroups']);
	}
	
	//Set some SQL Vars ;)
	$agroup_sql = '';
	$magroup_sql = '';
	$group_sql_and = '';

	if($currentGroup['is_post_group']) {
		$group_sql = 'ID_POST_GROUP = '.$currentGroup['id'];
		$group_sql_and = !empty($settings['hide_post_group']) ? 'ID_GROUP = 0' : '';
	}
	else {
		$group_sql = 'ID_GROUP = '.$currentGroup['id'];
		if($loadAdditionalGroups) {
			$agroup_sql = 'OR FIND_IN_SET('.$currentGroup['id'].', additionalGroups) > 0';
			$magroup_sql = 'OR FIND_IN_SET('.$currentGroup['id'].', mem.additionalGroups) > 0';
		}
	}
	//First count the current Filter counter 
	$request = db_query("
		SELECT COUNT(*)
		FROM {$db_prefix}members
		WHERE is_activated = 1
		AND $group_sql".(!empty($group_sql_and) ? " AND $group_sql_and" : "")." $agroup_sql", __FILE__, __LINE__);
	list ($context['num_members']) = mysql_fetch_row($request);
	mysql_free_result($request);

	// Set defaults for sort (realName) and start. (0)
	if (!isset($_REQUEST['sort']) || !isset($context['columns'][$_REQUEST['sort']]))
		$_REQUEST['sort'] = 'realName';

	if (!is_numeric($_REQUEST['start']))
	{
		if (preg_match('~^[^\'\\\\/]~' . ($context['utf8'] ? 'u' : ''), $func['strtolower']($_REQUEST['start']), $match) === 0)
			fatal_error('Hacker?', false);

		$_REQUEST['start'] = $match[0];

		$request = db_query("
			SELECT COUNT(*)
			FROM {$db_prefix}members
			WHERE LOWER(SUBSTRING(realName, 1, 1)) < '$_REQUEST[start]'
				AND is_activated = 1
		AND $group_sql".(!empty($group_sql_and) ? " AND $group_sql_and" : "")." $agroup_sql", __FILE__, __LINE__);
		list ($_REQUEST['start']) = mysql_fetch_row($request);
		mysql_free_result($request);
	}

	$context['letter_links'] = '';
	for ($i = 97; $i < 123; $i++)
		$context['letter_links'] .= '<a href="' . $scripturl . '?action=mlist;sa=position;position='.$currentGroup['id'].';start=' . chr($i) . '#letter' . chr($i) . '">' . strtoupper(chr($i)) . '</a> ';

	// Sort out the column information.
	foreach ($context['columns'] as $col => $dummy)
	{
		$context['columns'][$col]['href'] = $scripturl . '?action=mlist;sa=position;position='.$currentGroup['id'].';sort=' . $col . ';start=0';

		if (!isset($_REQUEST['desc']) && $col == $_REQUEST['sort'])
			$context['columns'][$col]['href'] .= ';desc';

		$context['columns'][$col]['link'] = '<a href="' . $context['columns'][$col]['href'] . '">' . $context['columns'][$col]['label'] . '</a>';
		$context['columns'][$col]['selected'] = $_REQUEST['sort'] == $col;
	}

	$context['sort_by'] = $_REQUEST['sort'];
	$context['sort_direction'] = !isset($_REQUEST['desc']) ? 'down' : 'up';

	// Construct the page index.
	$context['page_index'] = constructPageIndex($scripturl . '?action=mlist;sa=position;position='.$currentGroup['id'].';sort=' . $_REQUEST['sort'] . (isset($_REQUEST['desc']) ? ';desc' : ''), $_REQUEST['start'], $context['num_members'], $modSettings['defaultMaxMembers']);

	// Send the data to the template.
	$context['start'] = $_REQUEST['start'] + 1;
	$context['end'] = min($_REQUEST['start'] + $modSettings['defaultMaxMembers'], $context['num_members']);

	$context['page_title'] = $txt[308] . ' ' . $context['start'] . ' ' . $txt[311] . ' ' . $context['end']. ' ('.$currentGroup['name'].')';
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=mlist;sa=position;position='.$currentGroup['id'].';sort=' . $_REQUEST['sort'] . ';start=' . $_REQUEST['start'],
		'name' => &$context['page_title'],
		'extra_after' => ' (' . $txt[309] . ' ' . $context['num_members'] . ' ' . $txt[310] . ')'
	);

	// List out the different sorting methods...
	$sort_methods = array(
		'isOnline' => array(
			'down' => '(ISNULL(lo.logTime)' . (!allowedTo('moderate_forum') ? ' OR NOT mem.showOnline' : '') . ') ASC, realName ASC',
			'up' => '(ISNULL(lo.logTime)' . (!allowedTo('moderate_forum') ? ' OR NOT mem.showOnline' : '') . ') DESC, realName DESC'
		),
		'realName' => array(
			'down' => 'mem.realName ASC',
			'up' => 'mem.realName DESC'
		),
		'emailAddress' => array(
			'down' => (allowedTo('moderate_forum') || empty($modSettings['allow_hideEmail'])) ? 'mem.emailAddress ASC' : 'mem.hideEmail ASC, mem.emailAddress ASC',
			'up' => (allowedTo('moderate_forum') || empty($modSettings['allow_hideEmail'])) ? 'mem.emailAddress DESC' : 'mem.hideEmail DESC, mem.emailAddress DESC'
		),
		'websiteUrl' => array(
			'down' => 'LENGTH(mem.websiteURL) > 0 DESC, ISNULL(mem.websiteURL) ASC, mem.websiteURL ASC',
			'up' => 'LENGTH(mem.websiteURL) > 0 ASC, ISNULL(mem.websiteURL) DESC, mem.websiteURL DESC'
		),
		'ICQ' => array(
			'down' => 'LENGTH(mem.ICQ) > 0 DESC, ISNULL(mem.ICQ) OR mem.ICQ = 0 ASC, mem.ICQ ASC',
			'up' => 'LENGTH(mem.ICQ) > 0 ASC, ISNULL(mem.ICQ) OR mem.ICQ = 0 DESC, mem.ICQ DESC'
		),
		'AIM' => array(
			'down' => 'LENGTH(mem.AIM) > 0 DESC, ISNULL(mem.AIM) ASC, mem.AIM ASC',
			'up' => 'LENGTH(mem.AIM) > 0 ASC, ISNULL(mem.AIM) DESC, mem.AIM DESC'
		),
		'YIM' => array(
			'down' => 'LENGTH(mem.YIM) > 0 DESC, ISNULL(mem.YIM) ASC, mem.YIM ASC',
			'up' => 'LENGTH(mem.YIM) > 0 ASC, ISNULL(mem.YIM) DESC, mem.YIM DESC'
		),
		'MSN' => array(
			'down' => 'LENGTH(mem.MSN) > 0 DESC, ISNULL(mem.MSN) ASC, mem.MSN ASC',
			'up' => 'LENGTH(mem.MSN) > 0 ASC, ISNULL(mem.MSN) DESC, mem.MSN DESC'
		),
		'registered' => array(
			'down' => 'mem.dateRegistered ASC',
			'up' => 'mem.dateRegistered DESC'
		),
		'ID_GROUP' => array(
			'down' => 'ISNULL(mg.groupName) ASC, mg.groupName ASC',
			'up' => 'ISNULL(mg.groupName) DESC, mg.groupName DESC'
		),
		'posts' => array(
			'down' => 'mem.posts DESC',
			'up' => 'mem.posts ASC'
		)
	);

	$limit = $_REQUEST['start'];

	// Select the members from the database.
	$request = db_query("
		SELECT mem.ID_MEMBER
		FROM {$db_prefix}members AS mem" . ($_REQUEST['sort'] === 'isOnline' ? "
			LEFT JOIN {$db_prefix}log_online AS lo ON (lo.ID_MEMBER = mem.ID_MEMBER)" : '') . ($_REQUEST['sort'] === 'ID_GROUP' ? "
			LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = IF(mem.ID_GROUP = 0, mem.ID_POST_GROUP, mem.ID_GROUP))" : '') . "
		WHERE mem.is_activated = 1
		AND mem.{$group_sql}".(!empty($group_sql_and) ? " AND mem.{$group_sql_and}" : "")." $magroup_sql
		ORDER BY " . $sort_methods[$_REQUEST['sort']][$context['sort_direction']] . "
		LIMIT $limit, $modSettings[defaultMaxMembers]", __FILE__, __LINE__);
	printMemberListRows($request);
	mysql_free_result($request);

	// Add anchors at the start of each letter.
	if ($_REQUEST['sort'] == 'realName')
	{
		$last_letter = '';
		foreach ($context['members'] as $i => $dummy)
		{
			$this_letter = $func['strtolower']($func['substr']($context['members'][$i]['name'], 0, 1));

			if ($this_letter != $last_letter && preg_match('~[a-z]~', $this_letter) === 1)
			{
				$context['members'][$i]['sort_letter'] = htmlspecialchars($this_letter);
				$last_letter = $this_letter;
			}
		}
	}
}

function printMemberListRows($request)
{
</replace>

<edit file>
$themedir/ManageMembers.template.php
</edit file>

<search for>
function template_admin_browse()
{
</search for>

<replace>
// Template for editing Member List Filter settings.
function template_mlist_filter_settings()
{
	global $context, $settings, $options, $txt, $scripturl, $modSettings;

	echo '
	<form action="', $scripturl, '?action=viewmembers;sa=mlistsettings" method="post" accept-charset="', $context['character_set'], '">
		<table border="0" cellspacing="0" cellpadding="4" align="center" width="80%" class="tborder">
			<tr class="titlebg">
				<td colspan="2">', $txt['mlist_filter_title'], '</td>
			</tr>
			<tr class="windowbg2">
				<th width="50%" align="right">
					<label for="mlist_mlist_disableFilter_check">', $txt['mlist_disableFilter'], '</label></span>:
				</th>
				<td valign="top">
					<input type="checkbox" name="mlist_disableFilter" id="mlist_disableFilter_check"', empty($modSettings['mlist_disableFilter']) ? '' : ' checked="checked"', ' class="check" />
				</td>
			</tr>
			<tr class="windowbg2">
				<th width="50%" align="right">
					<label for="mlist_loadAdditionalGroups_check">', $txt['mlist_loadAdditionalGroups'], '</label></span>:
				</th>
				<td valign="top">
					<input type="checkbox" name="mlist_loadAdditionalGroups" id="mlist_loadAdditionalGroups_check"', empty($modSettings['mlist_loadAdditionalGroups']) ? '' : ' checked="checked"', ' class="check" />
				</td>
			</tr>
			<tr class="windowbg2">
				<th width="50%" align="right" valign="top">
					<label for="mlist_noAdditionalGroups_input" onclick="return openNoAdditionalGroupsList();">', $txt['mlist_noAdditionalGroups'], '</lable>:
				</th>
				<td valign="top" align="left"><a href="#" onclick="return openNoAdditionalGroupsList();">'.$txt['membergroups_title'].'</a><br />
					<div id="noAdditionalGroupsList" style="display:block;">';

	// List all the membergroups so the user can choose who may access this board.
	foreach ($context['groups_2'] as $group)
		echo '
						<label for="groups_2_', $group['id'], '"><input type="checkbox" name="mlist_noAdditionalGroups[]" value="', $group['id'], '" id="groups_2_', $group['id'], '"', $group['checked'] ? ' checked="checked"' : '', ' /> <span', $group['is_post_group'] ? ' style="border-bottom: 1px dotted;" title="' . $txt['mboards_groups_post_group'] . '"' : '', '>', $group['name'], '</span></label><br />';
	echo '
						<input type="checkbox" onclick="invertAll(this, this.form, \'mlist_noAdditionalGroups[]\');" /> <i>', $txt[737], '</i><br />
						<br /></div>
	<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
		//This Skript is only for Opening and Closing the group select list
		var noAdditionalGroupsStatus = false;
		
		function openNoAdditionalGroupsList() {
			if(noAdditionalGroupsStatus) {
				noAdditionalGroupsStatus = false;
				document.getElementById("noAdditionalGroupsList").style.display = "block";
			}
			else {
				noAdditionalGroupsStatus = true;
				document.getElementById("noAdditionalGroupsList").style.display = "none";
			}
		
			return false;
		}
	// ]]></script>
						
				</td>
			</tr>
			<tr class="windowbg2">
				<th width="50%" align="right" valign="top">
					<label for="mlist_notSearchableGroups_input" onclick="return openNotSearchableGroupsList();">', $txt['mlist_notSearchableGroups'], '</lable>:
				</th>
				<td valign="top" align="left"><a href="#" onclick="return openNotSearchableGroupsList();">'.$txt['membergroups_title'].'</a><br />
					<div id="notSearchableGroupsList" style="display:block;">';

	// List all the membergroups so the user can choose who may access this board.
	foreach ($context['groups'] as $group)
		echo '
						<label for="groups_', $group['id'], '"><input type="checkbox" name="mlist_notSearchableGroups[]" value="', $group['id'], '" id="groups_', $group['id'], '"', $group['checked'] ? ' checked="checked"' : '', ' /> <span', $group['is_post_group'] ? ' style="border-bottom: 1px dotted;" title="' . $txt['mboards_groups_post_group'] . '"' : '', '>', $group['name'], '</span></label><br />';
	echo '
						<input type="checkbox" onclick="invertAll(this, this.form, \'mlist_notSearchableGroups[]\');" /> <i>', $txt[737], '</i><br />
						<br /></div>
	<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
		//This Skript is only for Opening and Closing the group select list
		var notSearchableGroupsStatus = false;
		
		function openNotSearchableGroupsList() {
			if(notSearchableGroupsStatus) {
				notSearchableGroupsStatus = false;
				document.getElementById("notSearchableGroupsList").style.display = "block";
			}
			else {
				notSearchableGroupsStatus = true;
				document.getElementById("notSearchableGroupsList").style.display = "none";
			}
		
			return false;
		}
		
		function closeBoth() {
			openNotSearchableGroupsList();
			openNoAdditionalGroupsList();
			return false;
		}
		
		window.onload=closeBoth;
	// ]]></script>
						
				</td>
			</tr>
			<tr class="windowbg2">
				<td align="right" colspan="2">
					<input type="submit" name="save_settings" value="', $txt['membergroups_edit_save'], '" />
				</td>
			</tr>
		</table>
		<input type="hidden" name="sc" value="', $context['session_id'], '" />
	</form>';
}

function template_admin_browse()
{
</replace>

<edit file>
$themedir/Memberlist.template.php
</edit file>

<search for>
		// Display page numbers and the a-z links for sorting by name if not a result of a search.
		if (!isset($context['old_search']))
			echo '
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr>
						<td>', $txt[139], ': ', $context['page_index'], '</td>
						<td align="right">', $context['letter_links'] . '</td>
					</tr>
				</table>';
</search for>

<replace>
		// Display page numbers and the a-z links for sorting by name if not a result of a search.
		if (!isset($context['old_search'])) {
			echo '
				<form name="searchPosition" action="'.$scripturl.'?action=mlist;sa=position" method="post">';
			echo '
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr>
						<td>', $txt[139], ': ', $context['page_index'];
			if(!empty($context['groups'])) {
				echo '
							<select name="position" onChange="document.searchPosition.submit();">'.($context['ID_GROUP'] != 0 ? '' : '
								<option value="0"'.($context['ID_GROUP'] == 0 ? ' selected="selected"' : '').'>'.$txt['mlist_search_group'].'</option>');
				foreach($context['groups'] as $group) 
					echo '
								<option value="'.$group['id'].'"'.($group['id'] == $context['ID_GROUP'] ? ' selected="selected"' : '').'>'.$group['name'].'</option>';
				echo '
							</select>
							<input type="submit" value="'.$txt['quick_mod_go'].'">';
			}
			echo '
						</td>
						<td align="right">', $context['letter_links'] . '</td>
					</tr>
				</table>
				</form>';
		}
</replace>