<id>
din1031:mlistpositionfilter
</id>

<version>
1.0.2
</version>

<edit file>
$sourcedir/Admin.php
</edit file>

<search for>
						'all' => array($txt['view_all_members']),
</search for>

<replace>
						'all' => array($txt['view_all_members']),
						'mlistsettings' => array($txt['mlist_filter_title']),
</replace>

<edit file>
$sourcedir/ManageMembers.php
</edit file>

<search for>
		'all' => array('ViewMemberlist', 'moderate_forum'),
</search for>

<replace>
		'all' => array('ViewMemberlist', 'moderate_forum'),
		'mlistsettings' => array('ModifyMlistFilterSettings', 'moderate_forum'),
</replace>

<search for>
		'viewmembers' => array(
			'label' => $txt['view_all_members'],
			'description' => $txt['admin_members_list'],
			'url' => $scripturl . '?action=admin;area=viewmembers;sa=all',
			'is_selected' => $_REQUEST['sa'] == 'all',
		),
</search for>

<replace>
		'viewmembers' => array(
			'label' => $txt['view_all_members'],
			'description' => $txt['admin_members_list'],
			'url' => $scripturl . '?action=admin;area=viewmembers;sa=all',
			'is_selected' => $_REQUEST['sa'] == 'all',
		),
		'mlistsettings' => array(
			'label' => $txt['mlist_filter_title'],
			'description' => $txt['mlist_filter_desc'],
			'url' => $scripturl . '?action=viewmembers;sa=mlistsettings',
			'is_selected' => $_REQUEST['sa'] == 'mlistsettings',
		),
</replace>

<search for>
function jeffsdatediff($old)
{
</search for>

<replace>
//So here are the Settinge for the Member List filter... hope you need it :)
function ModifyMlistFilterSettings()
{
	global $txt, $scripturl, $context, $settings, $sc, $db_prefix, $modSettings, $smfFunc;

	// Setup the template.
	$context['sub_template'] = 'mlist_filter_settings';
	$context['page_title'] = $txt['mlist_filter_title'];

	// Wanna save this page?
	if (isset($_POST['save_settings']))
	{
		checkSession();
		
		//Allowed Groups ;)
		if(!empty($_POST['mlist_noAdditionalGroups'])) {
			$new_array = array();
			foreach($_POST['mlist_noAdditionalGroups'] as $i) {
				$i = (int) $i;
				if(!empty($i))
					$new_array[$i] = $i;
			}
			$_POST['mlist_noAdditionalGroups'] = implode(',', $new_array);
		}		
		
		if(!empty($_POST['mlist_notSearchableGroups'])) {
			$new_array = array();
			foreach($_POST['mlist_notSearchableGroups'] as $i) {
				$i = (int) $i;
				if(!empty($i))
					$new_array[$i] = $i;
			}
			$_POST['mlist_notSearchableGroups'] = implode(',', $new_array);
		}
		
		// Update the actual settings.
		updateSettings(array(
			'mlist_disableFilter' => empty($_POST['mlist_disableFilter']) ? '0' : '1',
			'mlist_loadAdditionalGroups' => empty($_POST['mlist_loadAdditionalGroups']) ? '0' : '1',
			'mlist_noAdditionalGroups' => empty($_POST['mlist_noAdditionalGroups']) ? '' : $_POST['mlist_noAdditionalGroups'],
			'mlist_notSearchableGroups' => empty($_POST['mlist_notSearchableGroups']) ? '' : $_POST['mlist_notSearchableGroups'],
		));

		redirectexit('action=admin;area=viewmembers;sa=mlistsettings');
	}

	//Load membergroups.
	$modSettings['mlist_noAdditionalGroups'] = !empty($modSettings['mlist_noAdditionalGroups']) ? explode(',', $modSettings['mlist_noAdditionalGroups']) : array();
	$modSettings['mlist_notSearchableGroups'] = !empty($modSettings['mlist_notSearchableGroups']) ? explode(',', $modSettings['mlist_notSearchableGroups']) : array();
	$request = $smfFunc['db_query']('', "
		SELECT group_name, id_group, min_posts
		FROM {$db_prefix}membergroups
		ORDER BY min_posts, id_group != 1, id_group != 2, id_group != 3, group_name", __FILE__, __LINE__);
	$context['groups'] = array();
	while ($row = $smfFunc['db_fetch_assoc']($request))
	{
		$context['groups'][(int) $row['id_group']] = array(
			'id' => $row['id_group'],
			'name' => trim($row['group_name']),
			'checked' => in_array($row['id_group'], $modSettings['mlist_notSearchableGroups']),
			'is_post_group' => $row['min_posts'] != -1,
		);
	}
	$smfFunc['db_free_result']($request);

	//No Moderators!!!
	unset($context['groups']['3']);

	//I Generate the Second array for the other System
	$context['groups_2'] = array();
	foreach($context['groups'] as $id => $value) {
		if(!$value['is_post_group']) {
			$value['checked'] = in_array($id, $modSettings['mlist_noAdditionalGroups']);
			$context['groups_2'][$id] = $value;
		}
	}
	
	//Sorry for the lazyness... but it's easier...
	loadLanguage('ManageBoards');
}

function jeffsdatediff($old)
{
</replace>

<edit file>
$sourcedir/Memberlist.php
</edit file>

<search for>
	// Set up the sort links.
	$context['sort_links'] = array();
</search for>

<replace>
	//Disabled?
	if(!empty($modSettings['mlist_disableFilter']))
		unset($subActions['position']);

	// Set up the sort links.
	$context['sort_links'] = array();
</replace>

<search for>
		'all' => array(&$txt['view_all_members'], 'MLAll', $context['listing_by'] == 'all'),
</search for>

<replace>
		'all' => array(&$txt['view_all_members'], 'MLAll', $context['listing_by'] == 'all'),
		'position' => array(&$txt['mlist_search_group'], 'MLPosition', $context['listing_by'] == 'position'),
</replace>

<search for>
	$context['can_send_pm'] = allowedTo('pm_send');
</search for>

<replace>
	$context['can_send_pm'] = allowedTo('pm_send');

	//Preload Membergoups :) and set some Standards
	if(empty($modSettings['mlist_disableFilter'])) {
		//Preload Membergoups :) and set some Standards
		global $db_prefix, $smfFunc;
		$context['id_group'] = 0; 

		$request = $smfFunc['db_query']('', "
			SELECT group_name, id_group, min_posts
			FROM {$db_prefix}membergroups
			WHERE id_group != 3
			ORDER BY min_posts, id_group != 1, id_group != 2, group_name", __FILE__, __LINE__);
		while ($row = $smfFunc['db_fetch_assoc']($request))
		{
			$context['groups'][(int) $row['id_group']] = array(
				'id' => $row['id_group'],
				'name' => trim($row['group_name']),
				'is_post_group' => $row['min_posts'] != -1,
			);
		}
		$smfFunc['db_free_result']($request);

		//This is really a fast way to remove the groups who not allowed to see :D
		if(!empty($modSettings['mlist_notSearchableGroups'])) {
			if(!is_array($modSettings['mlist_notSearchableGroups']))
				$modSettings['mlist_notSearchableGroups'] = explode(',', $modSettings['mlist_notSearchableGroups']);
			foreach($modSettings['mlist_notSearchableGroups'] as $id) 
				unset($context['groups'][$id]);
		}
		
		if(empty($context['groups']))
			$modSettings['mlist_disableFilter'] = '1';
	}
	else {
		$context['id_group'] = 0;
		$context['groups'] = array();
	}
</replace>

<search for>
function printMemberListRows($request)
{
</search for>

<replace>
// Filter Memberlist by Membergroups.
function MLPosition()
{
	global $txt, $scripturl, $db_prefix, $user_info, $settings;
	global $modSettings, $context, $smfFunc;

	if(!empty($modSettings['mlist_disableFilter']) || empty($context['groups'])) 
		redirectexit('action=mlist');

	//Nothing set? Hacking?
	$_REQUEST['position'] = !isset($_REQUEST['position']) ? 0 : (int) $_REQUEST['position'];
	
	if(empty($_REQUEST['position']) || !isset($context['groups'][$_REQUEST['position']])) 
		$currentGroup = current($context['groups']); //Take the first item i found ;)
	else
		$currentGroup = $context['groups'][$_REQUEST['position']];
	
	//Set the id for later.	
	$context['id_group'] = $currentGroup['id'];

	//Should i load Additional Groups or should i remove some groups from this?
	$loadAdditionalGroups = empty($modSettings['mlist_loadAdditionalGroups']);
	if($loadAdditionalGroups && !empty($modSettings['mlist_noAdditionalGroups'])) {
		if(!is_array($modSettings['mlist_noAdditionalGroups']))
			$modSettings['mlist_noAdditionalGroups'] = explode(',', $modSettings['mlist_noAdditionalGroups']);
		$loadAdditionalGroups = !in_array($context['id_group'], $modSettings['mlist_noAdditionalGroups']);
	}
	
	//Set some SQL Vars ;)
	$agroup_sql = '';
	$magroup_sql = '';
	$group_sql_and = '';

	if($currentGroup['is_post_group']) {
		$group_sql = 'ID_POST_GROUP = '.$currentGroup['id'];
		$group_sql_and = !empty($settings['hide_post_group']) ? 'id_group = 0' : '';
	}
	else {
		$group_sql = 'ID_GROUP = '.$currentGroup['id'];
		if($loadAdditionalGroups) {
			$agroup_sql = 'OR FIND_IN_SET('.$currentGroup['id'].', additional_groups) > 0';
			$magroup_sql = 'OR FIND_IN_SET('.$currentGroup['id'].', mem.additional_groups) > 0';
		}
	}
	//First count the current Filter counter 
	$request = $smfFunc['db_query']('', "
		SELECT COUNT(*)
		FROM {$db_prefix}members
		WHERE is_activated = 1
		AND $group_sql".(!empty($group_sql_and) ? " AND $group_sql_and" : "")." $agroup_sql", __FILE__, __LINE__);
	list ($context['num_members']) = $smfFunc['db_fetch_row']($request);
	$smfFunc['db_free_result']($request);

	// Set defaults for sort (real_name) and start. (0)
	if (!isset($_REQUEST['sort']) || !isset($context['columns'][$_REQUEST['sort']]))
		$_REQUEST['sort'] = 'real_name';

	if (!is_numeric($_REQUEST['start']))
	{
		if (preg_match('~^[^\'\\\\/]~' . ($context['utf8'] ? 'u' : ''), $smfFunc['strtolower']($_REQUEST['start']), $match) === 0)
			fatal_error('Hacker?', false);

		$_REQUEST['start'] = $match[0];

		$request = $smfFunc['db_query']('', "
			SELECT COUNT(*)
			FROM {$db_prefix}members
			WHERE LOWER(SUBSTRING(real_name, 1, 1)) < '$_REQUEST[start]'
				AND is_activated = 1
		AND $group_sql".(!empty($group_sql_and) ? " AND $group_sql_and" : "")." $agroup_sql", __FILE__, __LINE__);
		list ($_REQUEST['start']) = $smfFunc['db_fetch_row']($request);
		$smfFunc['db_free_result']($request);
	}

	$context['letter_links'] = '';
	for ($i = 97; $i < 123; $i++)
		$context['letter_links'] .= '<a href="' . $scripturl . '?action=mlist;sa=position;position='.$currentGroup['id'].';start=' . chr($i) . '#letter' . chr($i) . '">' . strtoupper(chr($i)) . '</a> ';

	// Sort out the column information.
	foreach ($context['columns'] as $col => $dummy)
	{
		$context['columns'][$col]['href'] = $scripturl . '?action=mlist;sort=' . $col . ';start=0';

		if (!isset($_REQUEST['desc']) && $col == $_REQUEST['sort'])
			$context['columns'][$col]['href'] .= ';desc';

		$context['columns'][$col]['link'] = '<a href="' . $context['columns'][$col]['href'] . '">' . $context['columns'][$col]['label'] . '</a>';
		$context['columns'][$col]['selected'] = $_REQUEST['sort'] == $col;
	}

	$context['sort_by'] = $_REQUEST['sort'];
	$context['sort_direction'] = !isset($_REQUEST['desc']) ? 'down' : 'up';

	// Construct the page index.
	$context['page_index'] = constructPageIndex($scripturl . '?action=mlist;sa=position;position='.$currentGroup['id'].';sort=' . $_REQUEST['sort'] . (isset($_REQUEST['desc']) ? ';desc' : ''), $_REQUEST['start'], $context['num_members'], $modSettings['defaultMaxMembers']);

	// Send the data to the template.
	$context['start'] = $_REQUEST['start'] + 1;
	$context['end'] = min($_REQUEST['start'] + $modSettings['defaultMaxMembers'], $context['num_members']);

	$context['can_moderate_forum'] = allowedTo('moderate_forum');
	$context['page_title'] = sprintf($txt['viewing_members'], $context['start'], $context['end']). ' ('.$currentGroup['name'].')';
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=mlist;sa=position;position='.$currentGroup['id'].';sort=' . $_REQUEST['sort'] . ';start=' . $_REQUEST['start'],
		'name' => &$context['page_title'],
		'extra_after' => ' (' . sprintf($txt['of_total_members'], $context['num_members']) . ')'
	);
	
	// List out the different sorting methods...
	$sort_methods = array(
		'is_online' => array(
			'down' => '(ISNULL(lo.log_time)' . (!allowedTo('moderate_forum') ? ' OR NOT mem.show_online' : '') . ') ASC, real_name ASC',
			'up' => '(ISNULL(lo.log_time)' . (!allowedTo('moderate_forum') ? ' OR NOT mem.show_online' : '') . ') DESC, real_name DESC'
		),
		'real_name' => array(
			'down' => 'mem.real_name ASC',
			'up' => 'mem.real_name DESC'
		),
		'email_address' => array(
			'down' => allowedTo('moderate_forum') ? 'mem.email_address ASC' : 'mem.hide_email ASC, mem.email_address ASC',
			'up' => allowedTo('moderate_forum') ? 'mem.email_address DESC' : 'mem.hide_email DESC, mem.email_address DESC'
		),
		'website_url' => array(
			'down' => 'LENGTH(mem.website_url) > 0 DESC, ISNULL(mem.website_url) ASC, mem.website_url ASC',
			'up' => 'LENGTH(mem.website_url) > 0 ASC, ISNULL(mem.website_url) DESC, mem.website_url DESC'
		),
		'icq' => array(
			'down' => 'LENGTH(mem.icq) > 0 DESC, ISNULL(mem.icq) OR mem.icq = 0 ASC, mem.icq ASC',
			'up' => 'LENGTH(mem.icq) > 0 ASC, ISNULL(mem.icq) OR mem.icq = 0 DESC, mem.icq DESC'
		),
		'aim' => array(
			'down' => 'LENGTH(mem.aim) > 0 DESC, ISNULL(mem.aim) ASC, mem.aim ASC',
			'up' => 'LENGTH(mem.aim) > 0 ASC, ISNULL(mem.aim) DESC, mem.aim DESC'
		),
		'yim' => array(
			'down' => 'LENGTH(mem.yim) > 0 DESC, ISNULL(mem.yim) ASC, mem.yim ASC',
			'up' => 'LENGTH(mem.yim) > 0 ASC, ISNULL(mem.yim) DESC, mem.yim DESC'
		),
		'msn' => array(
			'down' => 'LENGTH(mem.msn) > 0 DESC, ISNULL(mem.msn) ASC, mem.msn ASC',
			'up' => 'LENGTH(mem.msn) > 0 ASC, ISNULL(mem.msn) DESC, mem.msn DESC'
		),
		'registered' => array(
			'down' => 'mem.date_registered ASC',
			'up' => 'mem.date_registered DESC'
		),
		'id_group' => array(
			'down' => 'ISNULL(mg.group_name) ASC, mg.group_name ASC',
			'up' => 'ISNULL(mg.group_name) DESC, mg.group_name DESC'
		),
		'posts' => array(
			'down' => 'mem.posts DESC',
			'up' => 'mem.posts ASC'
		)
	);

	$limit = $_REQUEST['start'];

	// Select the members from the database.
	$request = $smfFunc['db_query']('', "
		SELECT mem.id_member
		FROM {$db_prefix}members AS mem" . ($_REQUEST['sort'] === 'is_online' ? "
			LEFT JOIN {$db_prefix}log_online AS lo ON (lo.id_member = mem.id_member)" : '') . ($_REQUEST['sort'] === 'id_group' ? "
			LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.id_group = IF(mem.id_group = 0, mem.id_post_group, mem.id_group))" : '') . "
		WHERE mem.is_activated = 1
		AND mem.{$group_sql}".(!empty($group_sql_and) ? " AND mem.{$group_sql_and}" : "")." $magroup_sql
		ORDER BY " . $sort_methods[$_REQUEST['sort']][$context['sort_direction']] . "
		LIMIT $limit, $modSettings[defaultMaxMembers]", __FILE__, __LINE__);
	printMemberListRows($request);
	$smfFunc['db_free_result']($request);

	// Add anchors at the start of each letter.
	if ($_REQUEST['sort'] == 'real_name')
	{
		$last_letter = '';
		foreach ($context['members'] as $i => $dummy)
		{
			$this_letter = $smfFunc['strtolower']($smfFunc['substr']($context['members'][$i]['name'], 0, 1));

			if ($this_letter != $last_letter && preg_match('~[a-z]~', $this_letter) === 1)
			{
				$context['members'][$i]['sort_letter'] = htmlspecialchars($this_letter);
				$last_letter = $this_letter;
			}
		}
	}
}

function printMemberListRows($request)
{
</replace>

<edit file>
$themedir/ManageMembers.template.php
</edit file>

<search for>
function template_admin_browse()
{
</search for>

<replace>
// Template for editing Member List Filter settings.
function template_mlist_filter_settings()
{
	global $context, $settings, $options, $txt, $scripturl, $modSettings;

	echo '
	<form action="', $scripturl, '?action=admin;area=viewmembers;sa=mlistsettings" method="post" accept-charset="', $context['character_set'], '">
		<table border="0" cellspacing="0" cellpadding="4" align="center" width="80%" class="tborder">
			<tr class="titlebg">
				<td colspan="2">', $txt['mlist_filter_title'], '</td>
			</tr>
			<tr class="windowbg2">
				<th width="50%" align="right">
					<label for="mlist_mlist_disableFilter_check">', $txt['mlist_disableFilter'], '</label></span>:
				</th>
				<td valign="top">
					<input type="checkbox" name="mlist_disableFilter" id="mlist_disableFilter_check"', empty($modSettings['mlist_disableFilter']) ? '' : ' checked="checked"', ' class="check" />
				</td>
			</tr>
			<tr class="windowbg2">
				<th width="50%" align="right">
					<label for="mlist_loadAdditionalGroups_check">', $txt['mlist_loadAdditionalGroups'], '</label></span>:
				</th>
				<td valign="top">
					<input type="checkbox" name="mlist_loadAdditionalGroups" id="mlist_loadAdditionalGroups_check"', empty($modSettings['mlist_loadAdditionalGroups']) ? '' : ' checked="checked"', ' class="check" />
				</td>
			</tr>
			<tr class="windowbg2">
				<th width="50%" align="right" valign="top">
					<label for="mlist_noAdditionalGroups_input" onclick="return openNoAdditionalGroupsList();">', $txt['mlist_noAdditionalGroups'], '</lable>:
				</th>
				<td valign="top" align="left"><a href="#" onclick="return openNoAdditionalGroupsList();">'.$txt['membergroups_title'].'</a><br />
					<div id="noAdditionalGroupsList" style="display:block;">';

	// List all the membergroups so the user can choose who may access this board.
	foreach ($context['groups_2'] as $group)
		echo '
						<label for="groups_2_', $group['id'], '"><input type="checkbox" name="mlist_noAdditionalGroups[]" value="', $group['id'], '" id="groups_2_', $group['id'], '"', $group['checked'] ? ' checked="checked"' : '', ' /> <span', $group['is_post_group'] ? ' style="border-bottom: 1px dotted;" title="' . $txt['mboards_groups_post_group'] . '"' : '', '>', $group['name'], '</span></label><br />';
	echo '
						<input type="checkbox" onclick="invertAll(this, this.form, \'mlist_noAdditionalGroups[]\');" /> <i>', $txt['membergroups_title'], '</i><br />
						<br /></div>
	<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
		//This Skript is only for Opening and Closing the group select list
		var noAdditionalGroupsStatus = false;
		
		function openNoAdditionalGroupsList() {
			if(noAdditionalGroupsStatus) {
				noAdditionalGroupsStatus = false;
				document.getElementById("noAdditionalGroupsList").style.display = "block";
			}
			else {
				noAdditionalGroupsStatus = true;
				document.getElementById("noAdditionalGroupsList").style.display = "none";
			}
		
			return false;
		}
	// ]]></script>
						
				</td>
			</tr>
			<tr class="windowbg2">
				<th width="50%" align="right" valign="top">
					<label for="mlist_notSearchableGroups_input" onclick="return openNotSearchableGroupsList();">', $txt['mlist_notSearchableGroups'], '</lable>:
				</th>
				<td valign="top" align="left"><a href="#" onclick="return openNotSearchableGroupsList();">'.$txt['membergroups_title'].'</a><br />
					<div id="notSearchableGroupsList" style="display:block;">';

	// List all the membergroups so the user can choose who may access this board.
	foreach ($context['groups'] as $group)
		echo '
						<label for="groups_', $group['id'], '"><input type="checkbox" name="mlist_notSearchableGroups[]" value="', $group['id'], '" id="groups_', $group['id'], '"', $group['checked'] ? ' checked="checked"' : '', ' /> <span', $group['is_post_group'] ? ' style="border-bottom: 1px dotted;" title="' . $txt['mboards_groups_post_group'] . '"' : '', '>', $group['name'], '</span></label><br />';
	echo '
						<input type="checkbox" onclick="invertAll(this, this.form, \'mlist_notSearchableGroups[]\');" /> <i>', $txt['membergroups_title'], '</i><br />
						<br /></div>
	<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
		//This Skript is only for Opening and Closing the group select list
		var notSearchableGroupsStatus = false;
		
		function openNotSearchableGroupsList() {
			if(notSearchableGroupsStatus) {
				notSearchableGroupsStatus = false;
				document.getElementById("notSearchableGroupsList").style.display = "block";
			}
			else {
				notSearchableGroupsStatus = true;
				document.getElementById("notSearchableGroupsList").style.display = "none";
			}
		
			return false;
		}
		
		function closeBoth() {
			openNotSearchableGroupsList();
			openNoAdditionalGroupsList();
			return false;
		}
		
		window.onload=closeBoth;
	// ]]></script>
						
				</td>
			</tr>
			<tr class="windowbg2">
				<td align="right" colspan="2">
					<input type="submit" name="save_settings" value="', $txt['membergroups_edit_save'], '" />
				</td>
			</tr>
		</table>
		<input type="hidden" name="sc" value="', $context['session_id'], '" />
	</form>';
}

function template_admin_browse()
{
</replace>


<edit file>
$themedir/Memberlist.template.php
</edit file>

<search for>
		// Display page numbers and the a-z links for sorting by name if not a result of a search.
		if (!isset($context['old_search']))
			echo '
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr>
						<td>', $txt['pages'], ': ', $context['page_index'], '</td>
						<td align="right">', $context['letter_links'] . '</td>
					</tr>
				</table>';
</search for>

<replace>
		// Display page numbers and the a-z links for sorting by name if not a result of a search.
		if (!isset($context['old_search'])) {
			echo '
				<form name="searchPosition" action="'.$scripturl.'?action=mlist;sa=position" method="post">';
			echo '
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr>
						<td>', $txt['pages'], ': ', $context['page_index'];
			if(!empty($context['groups'])) {
				echo '
							<select name="position" onChange="document.searchPosition.submit();">'.($context['id_group'] != 0 ? '' : '
								<option value="0"'.($context['id_group'] == 0 ? ' selected="selected"' : '').'>'.$txt['mlist_search_group'].'</option>');
			foreach($context['groups'] as $group) 
				echo '
								<option value="'.$group['id'].'"'.($group['id'] == $context['id_group'] ? ' selected="selected"' : '').'>'.$group['name'].'</option>';
			echo '
							</select>
							<input type="submit" value="'.$txt['quick_mod_go'].'">';
			}
			echo '
						</td>
						<td align="right">', $context['letter_links'] . '</td>
					</tr>
				</table>
				</form>';
		}
</replace>