<id>
din1031:mlistpositionfilter
</id>

<version>
1.1.0
</version>

<edit file>
$sourcedir/ManageMembers.php
</edit file>

<search for>
		'all' => array('ViewMemberlist', 'moderate_forum'),
</search for>

<replace>
		'all' => array('ViewMemberlist', 'moderate_forum'),
		'mlistsettings' => array('ModifyMlistFilterSettings', 'moderate_forum'),
</replace>

<search for>
			'viewmembers' => array(
				'title' => $txt[303],
				'description' => $txt[11],
				'href' => $scripturl . '?action=viewmembers;sa=all',
				'is_selected' => $_REQUEST['sa'] == 'all',
			),
</search for>

<replace>
			'viewmembers' => array(
				'title' => $txt[303],
				'description' => $txt[11],
				'href' => $scripturl . '?action=viewmembers;sa=all',
				'is_selected' => $_REQUEST['sa'] == 'all',
			),
			'mlistsettings' => array(
				'title' => $txt['mlist_filter_title'],
				'description' => $txt['mlist_filter_desc'],
				'href' => $scripturl . '?action=viewmembers;sa=mlistsettings',
				'is_selected' => $_REQUEST['sa'] == 'mlistsettings',
			),
</replace>

<search for>
function jeffsdatediff($old)
{
</search for>

<replace>
//So here are the Settinge for the Member List filter... hope you need it :)
function ModifyMlistFilterSettings()
{
	global $txt, $scripturl, $context, $settings, $sc, $db_prefix, $modSettings;

	// Setup the template.
	$context['sub_template'] = 'mlist_filter_settings';
	$context['page_title'] = $txt['mlist_filter_title'];

	// Wanna save this page?
	if (isset($_POST['save_settings']))
	{
		checkSession();
		
		global $func;
		//Allowed Groups ;)
		if(!empty($_POST['mlist_noAdditionalGroups'])) {
			$new_array = array();
			foreach($_POST['mlist_noAdditionalGroups'] as $i) {
				$i = (int) $i;
				if(!empty($i))
					$new_array[$i] = $i;
			}
			$_POST['mlist_noAdditionalGroups'] = implode(',', $new_array);
		}		
		
		if(!empty($_POST['mlist_notSearchableGroups'])) {
			$new_array = array();
			foreach($_POST['mlist_notSearchableGroups'] as $i) {
				$i = (int) $i;
				if(!empty($i))
					$new_array[$i] = $i;
			}
			$_POST['mlist_notSearchableGroups'] = implode(',', $new_array);
		}
		
		// Update the actual settings.
		updateSettings(array(
			'mlist_disableFilter' => empty($_POST['mlist_disableFilter']) ? '0' : '1',
			'mlist_loadAdditionalGroups' => empty($_POST['mlist_loadAdditionalGroups']) ? '0' : '1',
			'mlist_noAdditionalGroups' => empty($_POST['mlist_noAdditionalGroups']) ? '' : $_POST['mlist_noAdditionalGroups'],
			'mlist_notSearchableGroups' => empty($_POST['mlist_notSearchableGroups']) ? '' : $_POST['mlist_notSearchableGroups'],
		));

		redirectexit('action=viewmembers;sa=mlistsettings');
	}

	//Load membergroups.
	$modSettings['mlist_noAdditionalGroups'] = !empty($modSettings['mlist_noAdditionalGroups']) ? explode(',', $modSettings['mlist_noAdditionalGroups']) : array();
	$modSettings['mlist_notSearchableGroups'] = !empty($modSettings['mlist_notSearchableGroups']) ? explode(',', $modSettings['mlist_notSearchableGroups']) : array();
	$request = db_query("
		SELECT groupName, ID_GROUP, minPosts
		FROM {$db_prefix}membergroups
		ORDER BY minPosts, ID_GROUP != 1, ID_GROUP != 2, ID_GROUP != 3, groupName", __FILE__, __LINE__);
	$context['groups'] = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$context['groups'][(int) $row['ID_GROUP']] = array(
			'id' => $row['ID_GROUP'],
			'name' => trim($row['groupName']),
			'checked' => in_array($row['ID_GROUP'], $modSettings['mlist_notSearchableGroups']),
			'is_post_group' => $row['minPosts'] != -1,
		);
	}
	mysql_free_result($request);

	//No Moderators!!!
	unset($context['groups']['3']);

	//I Generate the Second array for the other System
	$context['groups_2'] = array();
	foreach($context['groups'] as $id => $value) {
		if(!$value['is_post_group']) {
			$value['checked'] = in_array($id, $modSettings['mlist_noAdditionalGroups']);
			$context['groups_2'][$id] = $value;
		}
	}
	
	//Sorry for the lazyness... but it's easier...
	loadLanguage('ManageBoards');
}

function jeffsdatediff($old)
{
</replace>

<edit file>
$sourcedir/Memberlist.php
</edit file>

<search for>
	// Set up the sort links.
	$context['sort_links'] = array();
</search for>

<replace>
	//Disabled?
	if(!empty($modSettings['mlist_disableFilter']))
		unset($subActions['position']);

	// Set up the sort links.
	$context['sort_links'] = array();
</replace>

<search for>
	//Preload Membergoups :) and set some Standards
	global $db_prefix;
	$context['ID_GROUP'] = 0; 
	
	$request = db_query("
		SELECT groupName, ID_GROUP, minPosts
		FROM {$db_prefix}membergroups
		WHERE ID_GROUP != 3
		ORDER BY minPosts, ID_GROUP != 1, ID_GROUP != 2, groupName", __FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($request))
	{
		$context['groups'][(int) $row['ID_GROUP']] = array(
			'id' => $row['ID_GROUP'],
			'name' => trim($row['groupName']),
			'is_post_group' => $row['minPosts'] != -1,
		);
	}
	mysql_free_result($request);
</search for>

<replace>
	if(empty($modSettings['mlist_disableFilter'])) {
		//Preload Membergoups :) and set some Standards
		global $db_prefix;
		$context['ID_GROUP'] = 0; 

		$request = db_query("
			SELECT groupName, ID_GROUP, minPosts
			FROM {$db_prefix}membergroups
			WHERE ID_GROUP != 3
			ORDER BY minPosts, ID_GROUP != 1, ID_GROUP != 2, groupName", __FILE__, __LINE__);
		while ($row = mysql_fetch_assoc($request))
		{
			$context['groups'][(int) $row['ID_GROUP']] = array(
				'id' => $row['ID_GROUP'],
				'name' => trim($row['groupName']),
				'is_post_group' => $row['minPosts'] != -1,
			);
		}
		mysql_free_result($request);

		//This is really a fast way to remove the groups who not allowed to see :D
		if(!empty($modSettings['mlist_notSearchableGroups'])) {
			if(!is_array($modSettings['mlist_notSearchableGroups']))
				$modSettings['mlist_notSearchableGroups'] = explode(',', $modSettings['mlist_notSearchableGroups']);
			foreach($modSettings['mlist_notSearchableGroups'] as $id) 
				unset($context['groups'][$id]);
		}
		
		if(empty($context['groups']))
			$modSettings['mlist_disableFilter'] = '1';
	}
	else {
		$context['ID_GROUP'] = 0;
		$context['groups'] = array();
	}
</replace>

<search for>
	//Nothing set? Hacking?
	$_REQUEST['position'] = !isset($_REQUEST['position']) ? 0 : (int) $_REQUEST['position'];
	if(empty($_REQUEST['position']) || !isset($context['groups'][$_REQUEST['position']]))
		$currentGroup = $context['groups'][1]; //Admins is the Standard for me ;)
	else
		$currentGroup = $context['groups'][$_REQUEST['position']];
	
	//Set the id for later.	
	$context['ID_GROUP'] = $currentGroup['id'];
	
	if($currentGroup['is_post_group']) {
		$group_sql = 'ID_POST_GROUP = '.$currentGroup['id'];
		$agroup_sql = '';
		$magroup_sql = '';
		$group_sql_and = !empty($settings['hide_post_group']) ? 'ID_GROUP = 0' : '';
	}
	else {
		$group_sql = 'ID_GROUP = '.$currentGroup['id'];
		$agroup_sql = 'OR FIND_IN_SET('.$currentGroup['id'].', additionalGroups) > 0';
		$magroup_sql = 'OR FIND_IN_SET('.$currentGroup['id'].', mem.additionalGroups) > 0';
		$group_sql_and = '';
	}
</search for>

<replace>
	if(!empty($modSettings['mlist_disableFilter']) || empty($context['groups'])) 
		redirectexit('action=mlist');

	//Nothing set? Hacking?
	$_REQUEST['position'] = !isset($_REQUEST['position']) ? 0 : (int) $_REQUEST['position'];
	
	if(empty($_REQUEST['position']) || !isset($context['groups'][$_REQUEST['position']])) 
		$currentGroup = current($context['groups']); //Take the first item i found ;)
	else
		$currentGroup = $context['groups'][$_REQUEST['position']];
	
	//Set the id for later.	
	$context['ID_GROUP'] = $currentGroup['id'];

	//Should i load Additional Groups or should i remove some groups from this?
	$loadAdditionalGroups = empty($modSettings['mlist_loadAdditionalGroups']);
	if($loadAdditionalGroups && !empty($modSettings['mlist_noAdditionalGroups'])) {
		if(!is_array($modSettings['mlist_noAdditionalGroups']))
			$modSettings['mlist_noAdditionalGroups'] = explode(',', $modSettings['mlist_noAdditionalGroups']);
		$loadAdditionalGroups = !in_array($context['ID_GROUP'], $modSettings['mlist_noAdditionalGroups']);
	}
	
	//Set some SQL Vars ;)
	$agroup_sql = '';
	$magroup_sql = '';
	$group_sql_and = '';

	if($currentGroup['is_post_group']) {
		$group_sql = 'ID_POST_GROUP = '.$currentGroup['id'];
		$group_sql_and = !empty($settings['hide_post_group']) ? 'ID_GROUP = 0' : '';
	}
	else {
		$group_sql = 'ID_GROUP = '.$currentGroup['id'];
		if($loadAdditionalGroups) {
			$agroup_sql = 'OR FIND_IN_SET('.$currentGroup['id'].', additionalGroups) > 0';
			$magroup_sql = 'OR FIND_IN_SET('.$currentGroup['id'].', mem.additionalGroups) > 0';
		}
	}
</replace>

<edit file>
$themedir/ManageMembers.template.php
</edit file>

<search for>
function template_admin_browse()
{
</search for>

<replace>
// Template for editing Member List Filter settings.
function template_mlist_filter_settings()
{
	global $context, $settings, $options, $txt, $scripturl, $modSettings;

	echo '
	<form action="', $scripturl, '?action=viewmembers;sa=mlistsettings" method="post" accept-charset="', $context['character_set'], '">
		<table border="0" cellspacing="0" cellpadding="4" align="center" width="80%" class="tborder">
			<tr class="titlebg">
				<td colspan="2">', $txt['mlist_filter_title'], '</td>
			</tr>
			<tr class="windowbg2">
				<th width="50%" align="right">
					<label for="mlist_mlist_disableFilter_check">', $txt['mlist_disableFilter'], '</label></span>:
				</th>
				<td valign="top">
					<input type="checkbox" name="mlist_disableFilter" id="mlist_disableFilter_check"', empty($modSettings['mlist_disableFilter']) ? '' : ' checked="checked"', ' class="check" />
				</td>
			</tr>
			<tr class="windowbg2">
				<th width="50%" align="right">
					<label for="mlist_loadAdditionalGroups_check">', $txt['mlist_loadAdditionalGroups'], '</label></span>:
				</th>
				<td valign="top">
					<input type="checkbox" name="mlist_loadAdditionalGroups" id="mlist_loadAdditionalGroups_check"', empty($modSettings['mlist_loadAdditionalGroups']) ? '' : ' checked="checked"', ' class="check" />
				</td>
			</tr>
			<tr class="windowbg2">
				<th width="50%" align="right" valign="top">
					<label for="mlist_noAdditionalGroups_input" onclick="return openNoAdditionalGroupsList();">', $txt['mlist_noAdditionalGroups'], '</lable>:
				</th>
				<td valign="top" align="left"><a href="#" onclick="return openNoAdditionalGroupsList();">'.$txt['membergroups_title'].'</a><br />
					<div id="noAdditionalGroupsList" style="display:block;">';

	// List all the membergroups so the user can choose who may access this board.
	foreach ($context['groups_2'] as $group)
		echo '
						<label for="groups_2_', $group['id'], '"><input type="checkbox" name="mlist_noAdditionalGroups[]" value="', $group['id'], '" id="groups_2_', $group['id'], '"', $group['checked'] ? ' checked="checked"' : '', ' /> <span', $group['is_post_group'] ? ' style="border-bottom: 1px dotted;" title="' . $txt['mboards_groups_post_group'] . '"' : '', '>', $group['name'], '</span></label><br />';
	echo '
						<input type="checkbox" onclick="invertAll(this, this.form, \'mlist_noAdditionalGroups[]\');" /> <i>', $txt[737], '</i><br />
						<br /></div>
	<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
		//This Skript is only for Opening and Closing the group select list
		var noAdditionalGroupsStatus = false;
		
		function openNoAdditionalGroupsList() {
			if(noAdditionalGroupsStatus) {
				noAdditionalGroupsStatus = false;
				document.getElementById("noAdditionalGroupsList").style.display = "block";
			}
			else {
				noAdditionalGroupsStatus = true;
				document.getElementById("noAdditionalGroupsList").style.display = "none";
			}
		
			return false;
		}
	// ]]></script>
						
				</td>
			</tr>
			<tr class="windowbg2">
				<th width="50%" align="right" valign="top">
					<label for="mlist_notSearchableGroups_input" onclick="return openNotSearchableGroupsList();">', $txt['mlist_notSearchableGroups'], '</lable>:
				</th>
				<td valign="top" align="left"><a href="#" onclick="return openNotSearchableGroupsList();">'.$txt['membergroups_title'].'</a><br />
					<div id="notSearchableGroupsList" style="display:block;">';

	// List all the membergroups so the user can choose who may access this board.
	foreach ($context['groups'] as $group)
		echo '
						<label for="groups_', $group['id'], '"><input type="checkbox" name="mlist_notSearchableGroups[]" value="', $group['id'], '" id="groups_', $group['id'], '"', $group['checked'] ? ' checked="checked"' : '', ' /> <span', $group['is_post_group'] ? ' style="border-bottom: 1px dotted;" title="' . $txt['mboards_groups_post_group'] . '"' : '', '>', $group['name'], '</span></label><br />';
	echo '
						<input type="checkbox" onclick="invertAll(this, this.form, \'mlist_notSearchableGroups[]\');" /> <i>', $txt[737], '</i><br />
						<br /></div>
	<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
		//This Skript is only for Opening and Closing the group select list
		var notSearchableGroupsStatus = false;
		
		function openNotSearchableGroupsList() {
			if(notSearchableGroupsStatus) {
				notSearchableGroupsStatus = false;
				document.getElementById("notSearchableGroupsList").style.display = "block";
			}
			else {
				notSearchableGroupsStatus = true;
				document.getElementById("notSearchableGroupsList").style.display = "none";
			}
		
			return false;
		}
		
		function closeBoth() {
			openNotSearchableGroupsList();
			openNoAdditionalGroupsList();
			return false;
		}
		
		window.onload=closeBoth;
	// ]]></script>
						
				</td>
			</tr>
			<tr class="windowbg2">
				<td align="right" colspan="2">
					<input type="submit" name="save_settings" value="', $txt['membergroups_edit_save'], '" />
				</td>
			</tr>
		</table>
		<input type="hidden" name="sc" value="', $context['session_id'], '" />
	</form>';
}

function template_admin_browse()
{
</replace>

<edit file>
$themedir/Memberlist.template.php
</edit file>

<search for>
		// Display page numbers and the a-z links for sorting by name if not a result of a search.
		if (!isset($context['old_search'])) {
			echo '
				<form name="searchPosition" action="'.$scripturl.'?action=mlist;sa=position" method="post">';
			echo '
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr>
						<td>', $txt[139], ': ', $context['page_index'], ' 
							<select name="position" onChange="document.searchPosition.submit();">'.($context['ID_GROUP'] != 0 ? '' : '
								<option value="0"'.($context['ID_GROUP'] == 0 ? ' selected="selected"' : '').'>'.$txt['mlist_search_group'].'</option>');
			foreach($context['groups'] as $group) 
				echo '
								<option value="'.$group['id'].'"'.($group['id'] == $context['ID_GROUP'] ? ' selected="selected"' : '').'>'.$group['name'].'</option>';
			echo '
							</select>
							<input type="submit" value="'.$txt['quick_mod_go'].'">
						</td>
						<td align="right">', $context['letter_links'] . '</td>
					</tr>
				</table>
				</form>';
		}
</search for>

<replace>
		// Display page numbers and the a-z links for sorting by name if not a result of a search.
		if (!isset($context['old_search'])) {
			echo '
				<form name="searchPosition" action="'.$scripturl.'?action=mlist;sa=position" method="post">';
			echo '
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr>
						<td>', $txt[139], ': ', $context['page_index'];
			if(!empty($context['groups'])) {
				echo '
							<select name="position" onChange="document.searchPosition.submit();">'.($context['ID_GROUP'] != 0 ? '' : '
								<option value="0"'.($context['ID_GROUP'] == 0 ? ' selected="selected"' : '').'>'.$txt['mlist_search_group'].'</option>');
				foreach($context['groups'] as $group) 
					echo '
								<option value="'.$group['id'].'"'.($group['id'] == $context['ID_GROUP'] ? ' selected="selected"' : '').'>'.$group['name'].'</option>';
				echo '
							</select>
							<input type="submit" value="'.$txt['quick_mod_go'].'">';
			}
			echo '
						</td>
						<td align="right">', $context['letter_links'] . '</td>
					</tr>
				</table>
				</form>';
		}
</replace>
